<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Import style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.13.3/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.13.3/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.13.3/js/dataTables.bootstrap4.min.js"></script>


</head>

<body>
  <!-- khUng lọc role  -->
  <div class="container-fluid">
    <h1 class="text-center">F200- LỊCH SỬ HỌC TẬP </h1>
  </div>
  <div class="container-fluid jumbotron">
    <div class="row">
      <h3 class="mb-5">Thông tin người chơi</h3>
    </div>
    <div class="row">

      <div class="col-sm-2 text-center">
        <label for="select-student">Student</label>
      </div>
      <div class="col-sm-2 input-group">
        <select id="select-student" class="form-control form-select" name="">
          <option value="-1">Chọn ...</option>
        </select>
      </div>
      <div class="col-sm-2 text-center">
        <label for="select-subject">Subject</label>
      </div>
      <div class="col-sm-2 input-group">
        <select id="select-subject" class="form-control form-select" name="">
          <option value="-1">Chọn ...</option>
        </select>
      </div>

      <div class="col-sm-2">
        <button id="btn-loc-role" class="btn btn-success form-control">Lọc Dữ Liệu</button>
      </div>
    </div>
  </div>
  <!-- bảng hiển thị thông tin người dùng  -->
  <div class="container-fluid">
    <table id="table-user" class="table table-striped table-hover table-bordered">
      <thead>
        <tr>
          <th>STT</th>
          <th>Student</th>
          <th>Môn học </th>
          <th>Điểm</th>
          <th>Ngày thi</th>
        </tr>
      </thead>
      <tbody></tbody>
    </table>

  </div>

</body>
<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  /* Mảng userObjects là mảng chứa dữ liệu user. Từng phần tử là object
  */
  var gStt = 0;
  var gStudents = [
    {
      id: 2, // tự tăng
      studentCode: "1356783",
      firstname: "Ngo Van",
      lastname: "Quan",
      age: 18,
      email: "quan@gmail.com",
      studyYear: 2015
    },
    {
      id: 3, // tự tăng
      studentCode: "1356784",
      firstname: "le huu",
      lastname: "vinh",
      age: 19,
      email: "vinh@gmail.com",
      studyYear: 2015
    },
    {
      id: 4, // tự tăng
      studentCode: "1356785",
      firstname: "vu thuy",
      lastname: "duong",
      age: 10,
      email: "duong@gmail.com",
      studyYear: 2015
    },
    {
      id: 5, // tự tăng
      studentCode: "1356786",
      firstname: "le nhat",
      lastname: "phuong",
      age: 15,
      email: "phuong@gmail.com",
      studyYear: 2015
    },
    {
      id: 6, // tự tăng
      studentCode: "1356787",
      firstname: "le duy",
      lastname: "han",
      age: 14,
      email: "quan@gmail.com",
      studyYear: 2015
    },

  ];

  var gSubjects = [
    {
      id: 2, // tự tăng
      subjectCode: "MATH101",
      subjectName: "Toán cao cấp 1"
    },
    {
      id: 3, // tự tăng
      subjectCode: "MATH102",
      subjectName: "Toán cao cấp 2"
    },
    {
      id: 4, // tự tăng
      subjectCode: "MATH103",
      subjectName: "Toán cao cấp 3"
    },
    {
      id: 5, // tự tăng
      subjectCode: "VANHOCHD1",
      subjectName: "văn học hiện đại 1"
    },
    {
      id: 6, // tự tăng
      subjectCode: "VANHOCHD2",
      subjectName: "văn học hiện đại 2"
    },
    // điền thêm 04 môn học nữa
  ];

  var gGrades = [
    {
      id: 2, // tự tăng
      studentId: 2,
      subjectId: 2,
      grade: 6,
      examDate: "13/04/2021"
    },
    {
      id: 3, // tự tăng
      studentId: 3,
      subjectId: 2,
      grade: 4,
      examDate: "13/04/2021"
    },
    {
      id: 4, // tự tăng
      studentId: 4,
      subjectId: 3,
      grade: 2,
      examDate: "13/04/2021"
    },
    {
      id: 5, // tự tăng
      studentId: 5,
      subjectId: 4,
      grade: 0,
      examDate: "13/04/2021"
    },
    {
      id: 6, // tự tăng
      studentId: 5,
      subjectId: 4,
      grade: 10,
      examDate: "13/04/2021"
    },
    {
      id: 7, // tự tăng
      studentId: 2,
      subjectId: 3,
      grade: 6,
      examDate: "13/04/2021"
    },
    {
      id: 8, // tự tăng
      studentId: 3,
      subjectId: 3,
      grade: 4,
      examDate: "13/04/2021"
    },
    {
      id: 9, // tự tăng
      studentId: 4,
      subjectId: 5,
      grade: 2,
      examDate: "13/04/2021"
    },
    {
      id: 10, // tự tăng
      studentId: 5,
      subjectId: 3,
      grade: 7,
      examDate: "13/04/2021"
    },
    {
      id: 11, // tự tăng
      studentId: 6,
      subjectId: 3,
      grade: 5,
      examDate: "13/04/2021"
    },
  ];

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function () {
    onPageLoading();
    $("#btn-loc-role").on("click", onLocDataClick);  // khai báo nút lọc dữ liệu 

  });

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onPageLoading() {
    "use strict"
    console.log("đã load xong thẻ body ");
    //Khi load trang web, hiển thị dữ liệu đối tượng bảng điểm ra DataTable
    loadDataTable();
    //Khi load trang, load dữ liệu cho 2 ô select Student và Subject ở vùng lọc dữ liệu
    loadDatagStudents();
    loadDataSelectSubject();
  }
  function onLocDataClick() {
    console.log("đã lọc dữ liệu");
    //Khi ấn lọc, filter và hiển thị lại bảng dữ liệu theo sinh viên và subject đã chọn
    // khai bao dữ liệu thu thập được 
    var vObjectData = {
      studentId: "",
      subjectId: ""
    }
    //b1 thu thập dữ liệu 
    readDataSubjectAndStudent(vObjectData);
    // b2 validate data  khác -1 .. 
    var vResult = validateDataSelectStudentAndSubject(vObjectData);  // kiểm tra nếu valuem = -1 thì thông  báo ra màn hình
    if (vResult) {
      // b3 lọc data và hiển thị lên table  lọc nối tiếp 
      //console.log(vObjectData);
      var vFiter =  filterDataGrade(vObjectData);
      //  hiển thị data đã lọc lên data table 
      getInsertRowTable(vFiter);
    }

  }

  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // hàm thêm từng dòng dữ liệu vào  data table 
  function loadDataTable() {
    // khai báo mảng chứa giá trị các cột 
    const ARRAY_NAME_COL = ["stt", "studentId", "subjectId", "grade", "examDate",];
    // định nghĩa số thứ tự cho các cột 
    const COL_STT = 0;
    const COL_STUDENT = 1;
    const COL_SUBJECT = 2;
    const COL_GRADE = 3;
    const COL_DATE = 4;
    // cấu hình lại table
    // Khi load (tải) trang thì hiển thị toàn bộ dữ liệu user (Tách thành 04 bước) => 1 bước 
    $("#table-user").DataTable({
      paging: true,   // phân trang
      lengthChange: true,  // ố bản ghi / mỗi trang
      searching: true,  // tìm kiếm 
      ordering: false,    //sắp xếp
      columns: [
        { data: ARRAY_NAME_COL[COL_STT] },
        { data: ARRAY_NAME_COL[COL_STUDENT] },
        { data: ARRAY_NAME_COL[COL_SUBJECT] },
        { data: ARRAY_NAME_COL[COL_GRADE] },
        { data: ARRAY_NAME_COL[COL_DATE] },
      ],
      columnDefs: [
        {
          targets: COL_STT,
          render: function () {
            gStt++;
            return gStt;
          },
          className: "text-center text-primary",
        },
        {
          targets: COL_STUDENT,
          render: renderStudentTable,
        },
        {
          targets: COL_SUBJECT,
          render: renderSubjectTable,
        },
      ],
    });
    getInsertRowTable(gGrades);
  }
  // thêm dữ liệu lên bảng data table 
  function getInsertRowTable(paramRes) {
    var vTable = $("#table-user").DataTable();
    vTable.clear();// xóa trắng tbody trước khi load dữ liệu  
    vTable.rows.add(paramRes);  // thêm data vào đây 
    vTable.draw();      // render dữ liệu ra bảng 
    gStt = 0;  // làm mới lại biến toàn cục,
    // $('#example').tooltip(options)
  }
  // render từ id student ra tên học sinh
  function renderStudentTable(paramStudent) {
    var vDieuKien = false;
    var vIndex = 0;
    while (!vDieuKien && gStudents.length > vIndex) {
      var vTen = "no data";
      if (paramStudent == gStudents[vIndex].id) {
        vTen = gStudents[vIndex].firstname + gStudents[vIndex].lastname;
        vDieuKien = false;
        return vTen;
      }
      vIndex++;
    }
  }
  // render từ id môn học ra tên môn học 
  function renderSubjectTable(paramStudent) {
    var vDieuKien = false;
    var vIndex = 0;
    while (!vDieuKien && gSubjects.length > vIndex) {
      var vTen = "no data";
      if (paramStudent == gSubjects[vIndex].id) {
        vTen = gSubjects[vIndex].subjectName;
        vDieuKien = false;
        return vTen;
      }
      vIndex++;
    }
  }

  // đổ dữ liệu vào option student 
  function loadDatagStudents() {
    //truy cập ô select students và dùng vòng lặp đổ dưx liệu vào  
    for (var i = 0; i < gStudents.length; i++) {
      var vSelectRow = $("<option>"); // tạo 1 option 
      vSelectRow.val(gStudents[i].id);
      vSelectRow.html(gStudents[i].firstname + " " + gStudents[i].lastname);
      $("#select-student").append(vSelectRow);
    }
  }


  // đổ dữ liệu vào ô seclect  subject
  function loadDataSelectSubject() {
    for (var i = 0; i < gSubjects.length; i++) {
      var vSelectRow = $("<option>"); // tạo 1 option 
      vSelectRow.val(gSubjects[i].id);
      vSelectRow.html(gSubjects[i].subjectName);
      $("#select-subject").append(vSelectRow);
    }

  }
  // ..............................[[ VÙNG KHAI BÁO CHO NÚT LỌC DỮ LIỆU ]].........................
  // b1 đọc data từ ô select subject và student
  function readDataSubjectAndStudent(paramObject) {
    paramObject.studentId = $("#select-student").val();
    paramObject.subjectId = $("#select-subject").val();
  }
  // b2 kiểm tra dữ liệu 
  function validateDataSelectStudentAndSubject(paramObject) {
    if (paramObject.studentId == "-1") {
      alert("Bạn phải chọn select student");
      return false;
    }
    if (paramObject.subjectId == "-1") {
      alert("Bạn phải chọn select subject");
      return false;
    }
    return true;
  }
  // b3 lọc data 
  function filterDataGrade(paramObject) {
    // lọc lần 1 lọc student bằng gGrades
    var  filterStudent = gGrades.filter(function (str) {
        var vArr = str.studentId;
        return vArr == paramObject.studentId;
       });
    // lọc lần 2 . lọc subject   bằng  filterStudent
    var  filterSubject = filterStudent.filter(function (str) {
        var vArr = str.subjectId;
        return vArr == paramObject.subjectId;
       });  
       return   filterSubject;
  }


  function a() {
    var  filtered = gUserObjects.filter(function (str) {
        var vArr = str.roleId;
        return vArr == vRoleID;
       });
  }



</script>

</html>